/*
 * Sample code which inserts and deletes the rows in a table at runtime. If you
 * are using 1.8.2 and click on the rows quickly, then after some point the
 * application will stop responding and will encounter a JNI crash.
 *  
 */


/**
 * This method creates the a view inside which the table is displayed.
 */
function buildDetailBottomView(mainWindow) {
        var bottomView = Ti.UI.createView({
            width : '100%',
            bottom : '0',
        });
        
        bottomView.top = 100;
        mainWindow.add(bottomView);
        return bottomView;
    }
    
    
/**
 * This method creates the tableview.
 */
function createNewsTableView(bottomView, tableType) {
        bottomView.newsTableView = Titanium.UI.createTableView({
            top : 0,
            backgroundColor : '#EBEBEB',
            scrollable : true,
            zIndex : 1,
            height : 400
        });
        
        bottomView.newsTableView.style = Titanium.UI.iPhone.TableViewStyle.GROUPED;
        bottomView.newsTableView.backgroundColor = 'white';

        bottomView.add(bottomView.newsTableView);
        return bottomView.newsTableView;
    }
    
    
    var customerExpandData = [];
    
        function createNewsTableRow(tableView, homeResponse, tableType, page) {
        
        Ti.API.info("The response length is: " + homeResponse.length);

        if((homeResponse != null) && (homeResponse.length > 0)) {
            for(var i = 0; i < homeResponse.length; i++) {
                var newsRow = Titanium.UI.createTableViewRow({
                    height : 50,
                    itemDetailDataURI : homeResponse[i].DetailDataURI,
                    itemDetailPageId : homeResponse[i].DetailPageId,
                    detailItemId : homeResponse[homeResponse.length - 1].ItemId,
                    windowTitle : homeResponse[i].Title,
                    tableType : tableType,
                    rowType : 'expand',
                    clicked : 'false',
                    childrens : '0',
                    rowNumber : i,
                    tableObj : tableView,
                    backgroundColor : 'yellow',
                });

                newsRow.color = '#153E7E';

                switch(tableType) {

                    
                    case 'expanded':
                        tableView.newsheaderLabel = Titanium.UI.createLabel({
                            left : '3%',
                            //top : '20%',
                            top : 6,
                            width : '85%',
                            wordWrap : false,
                            ellipsize : true,
                            height : 25,
                            text : homeResponse[i].Title,
                            color : '#153E7E',
                            font : {
                                fontSize : 17.5,
                                fontFamily : 'Helvetica Neue',
                                fontWeight : 'bold'
                            },

                        });

                        tableView.newsLabel = Titanium.UI.createLabel({
                            left : '3%',
                            editable : 'false',
                            scrollable : 'false',
                            //top : '40%',
                            top : 21,
                            wordWrap : false,
                            ellipsize : true,
                            text : homeResponse[i].Preview,
                            color : '#818181',
                            font : {
                                fontSize : 13,
                                fontFamily : 'Helvetica Neue',
                            },
                            height : 25,
                            width : '90%',
                        });

                        tableView.expandImage = Titanium.UI.createImageView({
                            image : 'expand.png',
                            right : Ti.App.rigtMargin,
                            width : 'auto',
                            height : 'auto',
                            visible : true
                        });

                        tableView.collapseImage = Titanium.UI.createImageView({
                            image : 'collapse.png',
                            right : Ti.App.rigtMargin,
                            width : 'auto',
                            height : 'auto',
                            visible : false
                        });

                        newsRow.add(tableView.newsheaderLabel);
                        newsRow.add(tableView.newsLabel);
                        newsRow.add(tableView.expandImage);
                        newsRow.add(tableView.collapseImage);

                        customerExpandData.push(newsRow);
                        break;
                }
            }

            Ti.App.customerExpandData = customerExpandData;
            tableView.setData(Ti.App.customerExpandData);
            if(Ti.Platform.osname == "android") {
                if(customerExpandData.length > 10) {
                    tableView.setHeight((customerExpandData.length) * (51 ) + 30 );
                    //pull to refresh
                } else {
                    tableView.setHeight(10 * (50 ) + 30 );
                    //pull to refresh
                }
                
                Ti.API.info("The tableView height has been set. " + tableView.height);
            }
            customerExpandData = [];
            //customerExpandTableFlag=1;

        }
        return tableView;
        // pull to refresh
    }
    
    
    
    function setStatusTableEventListeners(w, detailGroupTableView, detailExpandTableView, pageId, newsDetailsResponse, backButton) {


        if (pageId == '50009') {
            detailExpandTableView.addEventListener('click', function(e) {

                if (detailExpandTableView.data[0].rows[e.index] != undefined) {
                    var itemDetailDataURI = detailExpandTableView.data[0].rows[e.index].itemDetailDataURI;
                    var itemDetailPageId = detailExpandTableView.data[0].rows[e.index].itemDetailPageId;
                    var detailItemId = detailExpandTableView.data[0].rows[e.index].detailItemId;
                    var windowTitle = detailExpandTableView.data[0].rows[e.index].windowTitle;
                    var sourceTable = 'expandtable';
                    var sourceTableResponse = newsDetailsResponse;
                    handlenewsTableEvent(e, w, detailExpandTableView, sourceTable, itemDetailDataURI, itemDetailPageId, detailItemId, sourceTableResponse, windowTitle);
                }

            });
        }

    }
    
    
    
    
    
    function handlenewsTableEvent(e, w, newstable, sourceTable, SourceDetailDataURI, SourceDetailPageId, SourceItemId, sourceName, windowTitle) {
        Ti.API.info('==============================================================');
        Ti.API.info('Source table is        : ' + sourceTable);
        Ti.API.info('Source details page Id : ' + SourceDetailPageId);
        Ti.API.info('Row type is            : ' + e.row.rowType);
        Ti.API.info('Index is               : ' + e.index);
        Ti.API.info('Last clicked time      : ' + Ti.App.lastClickedTime);
        Ti.API.info('==============================================================');
        
        var nowClickTimeObj = new Date();
        if((0 == Ti.App.lastClickedTime) || (500 >= (nowClickTimeObj.getTime() - Ti.App.lastClickedTime))) {
            Ti.API.error("################## Multiple click has been detected #################");
            return;
        }
        
        //Update the last clicked time
        Ti.App.lastClickedTime = nowClickTimeObj.getTime();

        var indexVal = e.index + 1;
            
            Ti.App.lastClickedTime = 0;
            
            var clickedRow = e.row;
            
            //Collapses the row when clicked on the row displaying the expand-collapse image
            if (e.row.rowType == 'collapse') {
                
                if((undefined == newstable.data[0].rows[e.index].children[2]) ||
                   (undefined == newstable.data[0].rows[e.index].children[3])) {
                       
                   Ti.App.lastClickedTime = nowClickTimeObj.getTime();
                   return;
                }
                
                if (newstable.data[0].rows[e.index].children[2] != undefined) {
                    newstable.data[0].rows[e.index].children[2].visible = true;
                }
                if (newstable.data[0].rows[e.index].children[3] != undefined) {
                    newstable.data[0].rows[e.index].children[3].visible = false;
                }
                e.row.rowType = 'expand';
                var rowNumber = parseInt(e.index) + 1;
                //newstable.deleteRow(rowNumber);
                if (newstable.data[0].rows[rowNumber] != undefined) {
                    if (Ti.Platform.osname == "android") {
                        Ti.API.info("newstable.data[0].rows[e.index + 1].getHeight() is =======" + newstable.data[0].rows[e.index + 1].getHeight());
                        newstable.setHeight(newstable.getHeight() - newstable.data[0].rows[e.index + 1].getHeight());
                    }
                    
                    if('detailedRow' == newstable.data[0].rows[rowNumber].rowType) {
                        newstable.deleteRow(rowNumber);
                    }
                }
                
                Ti.App.lastClickedTime = nowClickTimeObj.getTime();
                
                
            //Expands the row
            } else if (e.row.rowType == 'expand') {
                
                if((undefined == newstable.data[0].rows[e.index].children[2]) ||
                   (undefined == newstable.data[0].rows[e.index].children[3])) {
                       
                   Ti.App.lastClickedTime = nowClickTimeObj.getTime();
                   return;
                }
                
                e.row.rowType = 'collapse';
                buildExpandableList(e, sourceName, SourceDetailPageId,'favorites');
                if (ExpandedArrowFlag == 1) {
                    if (newstable.data[0].rows[e.index].children[2] != undefined) {
                        newstable.data[0].rows[e.index].children[2].visible = false;
                    }
                    if (newstable.data[0].rows[e.index].children[3] != undefined) {
                        newstable.data[0].rows[e.index].children[3].visible = true;
                    }
                }
                //sourceName -> parsed content
                Ti.App.lastClickedTime = nowClickTimeObj.getTime();
                
                
            //Collapses the row when clicked on the row which displays the details
            } else if (e.row.rowType == 'detailedRow') {
                
                if((undefined == newstable.data[0].rows[e.index-1].children[2]) ||
                   (undefined == newstable.data[0].rows[e.index-1].children[3])) {
                       
                   Ti.App.lastClickedTime = nowClickTimeObj.getTime();
                   return;
                }
                
                e.row.rowType = 'detailedRow';
                newstable.data[0].rows[e.index - 1].rowType = 'expand';
                if (newstable.data[0].rows[e.index-1].children[2] != undefined) {
                    newstable.data[0].rows[e.index-1].children[2].visible = true;
                }
                if (newstable.data[0].rows[e.index-1].children[3] != undefined) {
                    newstable.data[0].rows[e.index-1].children[3].visible = false;
                }
                if (newstable.data[0].rows[e.index] != undefined) {
                    if (Ti.Platform.osname == "android") {
                        Ti.API.info("newstable.data[0].rows[e.index].getHeight() is =======" + newstable.data[0].rows[e.index].getHeight());
                        newstable.setHeight(newstable.getHeight() - newstable.data[0].rows[e.index].getHeight());
                    }
                    
                    if('detailedRow' == newstable.data[0].rows[e.index].rowType) {
                        newstable.deleteRow(e.index);
                    }
                }
                
                Ti.App.lastClickedTime = nowClickTimeObj.getTime();
            }
            
            //Update the time
            Ti.App.lastClickedTime = nowClickTimeObj.getTime();
        }
    
    
    
    
    function buildExpandableList(newsRow, parsedContent, pageId, page) {
        ExpandedListClicked = false;
        newsRow.row.clicked = 'true';
        var topLabel = 5 ;
        if((parsedContent != null) && (parsedContent.length > 0)) {
            ExpandedArrowFlag = 1;
            if(pageId == '50008') {
                newsRow.row.childrens = parsedContent.length;
                var expandableHeight = 20 * parsedContent.length;
                if(parsedContent.length > 0) {
                    row = createExpandableRow(newsRow, parsedContent, pageId, topLabel, expandableHeight, page);
                    // 50008 expandable list using external service
                } else {
                    errorTitle = 'Error';
                    customError = 'No Items Available!';
                    customErrorNo = 0;
                    buildCustomAlert(errorTitle, customError, customErrorNo);
                }
            } else {
                if(parsedContent.length > 0) {
                    row = createExpandableRowDetails(newsRow, parsedContent, pageId, topLabel, expandableHeight,page);
                } else {
                    errorTitle = 'Error';
                    customError = 'No Items Available!';
                    customErrorNo = 0;
                    buildCustomAlert(errorTitle, customError, customErrorNo);
                }
            }
        } else {
            ExpandedArrowFlag = 0;
        }
        /* End Of Case */
        
        if(pageId == '50008') {
            var cDate = new Date();
            Ti.App.lastClickedTime = cDate.getTime();
        }
        return newsRow;
    }
    
    
    function getLeftTableWidth(leftLabelText, rightLabelText) {

        var leftLabelLen = (null == leftLabelText ? 0 : leftLabelText.length);
        var rightLabelLen = (null == rightLabelText ? 0 : rightLabelText.length);

        if(0 == (leftLabelLen - rightLabelLen)) {
            return 50;

        } else if(leftLabelLen > rightLabelLen) {

            if(10 >= (leftLabelLen - rightLabelLen)) {
                return 60;

            } else {
                return 70;

            }

        } else if(leftLabelLen < rightLabelLen) {

            if(-10 <= (leftLabelLen - rightLabelLen)) {
                return 40;

            } else if(-10 > (leftLabelLen - rightLabelLen)) {
                return 30;

            }
        }
    }
    
    
    function createExpandableRowDetails(newsRow, parsedContent, pageId, topLabel, expandableHeight,page) {
        
        if(parsedContent[newsRow.row.rowNumber] != undefined) {
            var detailsLength = parsedContent[newsRow.row.rowNumber].Details;
            if((detailsLength != null) && (detailsLength.length > 0) &&(detailsLength != undefined)){
                ExpandedArrowFlag = 1;
                var expandableHeight = 20 * detailsLength.length;
                newsRow.row.childrens = detailsLength.length;

                var row = Titanium.UI.createTableViewRow({
                    rowType : 'detailedRow',
                    backgroundColor : '#EBEBEB',
                });

                var rowViewView = Ti.UI.createView({
                    left : 0,
                    top : 0,
                    width : '100%',
                    height : 'auto',
                    layout : 'vertical'
                });

                row.height = (expandableHeight + 5) ;
                for(var i = 0; i < detailsLength.length; i++) {

                    var vw = Ti.UI.createView({
                        left : 0,
                        top : 5,
                        width : '100%',
                        height : Ti.UI.SIZE
                    });

                    var leftLabel = Titanium.UI.createLabel({
                        left : '3%',
                        top : 0,
                        //width : 'auto',
                        color : '#000000',
                        font : {
                            fontSize : 12.5,
                            fontFamily : 'Helvetica Neue',
                        },
                        //height : 20,
                        height : Ti.UI.SIZE,
                        text : detailsLength[i].Label,
                        textAlign : Ti.UI.TEXT_ALIGNMENT_LEFT
                    });

                    var rightLabel = Titanium.UI.createLabel({
                        right : '3%',
                        top : 0,
                        //width : 'auto',
                        color : '#000000',
                        font : {
                            fontSize : 12.5,
                            fontFamily : 'Helvetica Neue',

                        },
                        text : detailsLength[i].Text,
                        height : Ti.UI.SIZE,
                        //height : 20,
                        textAlign : Ti.UI.TEXT_ALIGNMENT_RIGHT
                    });

                    var lWidth = getLeftTableWidth(detailsLength[i].Label, detailsLength[i].Text);

                    //3% is sub from both because left and right padding is present
                    switch(lWidth) {
                        case 30:
                            leftLabel.width = '27%';
                            rightLabel.width = '67%';
                            break;

                        case 40:
                            leftLabel.width = '37%';
                            rightLabel.width = '57%';
                            break;

                        case 50:
                            leftLabel.width = '47%';
                            rightLabel.width = '47%';
                            break;

                        case 60:
                            leftLabel.width = '57%';
                            rightLabel.width = '37%';
                            break;

                        case 70:
                            leftLabel.width = '67%';
                            rightLabel.width = '27%';
                            break;

                        default:
                            leftLabel.width = '47%';
                            rightLabel.width = '47%';
                    }
                    if(page == 'summary') {
                        leftLabel.font = {
                            fontWeight : 'bold',
                            fontSize : 12.5,
                            fontFamily : 'Helvetica Neue',

                        };
                    } else {
                        if(detailsLength[i].LabelStyle == 'bold') {
                            leftLabel.font = {
                                fontWeight : 'bold',
                                fontSize : 12.5,
                                fontFamily : 'Helvetica Neue',
                            };
                        }
                        if(detailsLength[i].TextStyle == 'bold') {
                            rightLabel.font = {
                                fontWeight : 'bold',
                                fontSize : 12.5,
                                fontFamily : 'Helvetica Neue',
                            };
                        }

                    }

                    vw.add(leftLabel);
                    vw.add(rightLabel);
                    rowViewView.add(vw);
                    topLabel = topLabel + 20 ;
                }

                row.add(rowViewView);
                
                if(Ti.Platform.osname == 'android'){
                var t = newsRow.index;
                newsRow.row.tableObj.insertRowAfter(t, row);
                }

                if(Ti.Platform.osname == 'iphone') {
                    /*
                     * Make the height of the rows equally space and see to it that none
                     * of the labels gets overlapped with one another vertically. This
                     * is mainly done for iPhone.
                     */
                    var rowViewViewHeight = 0;
                    for(var k = 0; k < rowViewView.children.length; k++) {

                        var leftTextHeight = 0;
                        if ((null != (rowViewView.children[k]).children[0]) && ("" != (rowViewView.children[k]).children[0].text) && ((null != (rowViewView.children[k]).children[0].text))) {
                            leftTextHeight = calcLabelHeight((rowViewView.children[k]).children[0].text, (rowViewView.children[k]).children[0].width);
                        }

                        var rightTextHeight = 0;
                        if ((null != (rowViewView.children[k]).children[1]) && ("" != (rowViewView.children[k]).children[1].text) && ((null != (rowViewView.children[k]).children[1].text))) {
                            rightTextHeight = calcLabelHeight((rowViewView.children[k]).children[1].text, (rowViewView.children[k]).children[1].width);
                        }

                        (rowViewView.children[k]).height = (leftTextHeight > rightTextHeight ? leftTextHeight : rightTextHeight);
                        rowViewViewHeight += ((rowViewView.children[k]).height + (5 ));
                    }

                    row.height = rowViewViewHeight + (5 );
                } else {
                    row.height = rowViewView.toImage().height;

                }
                if(Ti.Platform.osname == "iphone"){
                //fixed the expandable view issue observed in iphone.
                var t = newsRow.index;
                newsRow.row.tableObj.insertRowAfter(t, row);
                }

                if(Ti.Platform.osname == "android") {
                    /*
                     if(Ti.App.detailedOpened == true){
                     Ti.App.newdetailedOpened = true;
                     }*/

                    Ti.API.info("createExpandableRowDetails row.height is ============= " + row.height);
                    newsRow.row.tableObj.setHeight(newsRow.row.tableObj.getHeight() + row.height);
                }
            } else {
                ExpandedArrowFlag = 0;
            }
        }
    }




var newsRes = [
    {
        "StatusCode": 0,
        "UserMessage": null,
        "DetailDataURI": null,
        "DetailPageId": 0,
        "Details": [
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Origin",
                "LabelStyle": "",
                "Text": "Tachikawa, Tokyo, Japan",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Destination",
                "LabelStyle": "",
                "Text": "Takao, Tokyo, Japan",
                "TextStyle": ""
            }
        ],
        "ItemId": null,
        "Preview": "",
        "Title": "Start"
    },
    {
        "StatusCode": 0,
        "UserMessage": null,
        "DetailDataURI": null,
        "DetailPageId": 0,
        "Details": [
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Contact",
                "LabelStyle": "",
                "Text": "Big Man",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Phone",
                "LabelStyle": "",
                "Text": "1 - 000 000-0000  x 000",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Fax",
                "LabelStyle": "",
                "Text": "00000000",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Email",
                "LabelStyle": "",
                "Text": "bigman@democompany.com",
                "TextStyle": ""
            }
        ],
        "ItemId": null,
        "Preview": "Test subline",
        "Title": "Test Header"
    },
    {
        "StatusCode": 0,
        "UserMessage": null,
        "DetailDataURI": null,
        "DetailPageId": 0,
        "Details": [
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Date",
                "LabelStyle": "",
                "Text": "06 Sep 2011",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Dates",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Scheduled",
                "LabelStyle": "",
                "Text": "23 Mar 2012 - 24 Mar 2012",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Dates",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Scheduled",
                "LabelStyle": "",
                "Text": "25 Mar 2012",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Delivery",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Scheduled",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Delivery",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Scheduled",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Delivery",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Scheduled",
                "LabelStyle": "",
                "Text": "27 Mar 2012",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Details",
                "LabelStyle": "bold",
                "Text": "",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Est.",
                "LabelStyle": "",
                "Text": "Heavy",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": null,
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Est.",
                "LabelStyle": "",
                "Text": "1",
                "TextStyle": ""
            },
            {
                "StatusCode": 0,
                "UserMessage": null,
                "Label": "Actual",
                "LabelStyle": "",
                "Text": null,
                "TextStyle": ""
            }
        ],
        "ItemId": null,
        "Preview": "",
        "Title": "Test Details"
    }
];


var win = Ti.UI.createWindow({
    navBarHidden : true,
    exitOnClose : true,
});

var bottomView = buildDetailBottomView(win);
var detailExpandTableView = createNewsTableView(bottomView, 'expanded');
var detailExpandTableRow = createNewsTableRow(detailExpandTableView, newsRes, 'expanded', 'statusDetail');
setStatusTableEventListeners(win, null, detailExpandTableView, 50009, newsRes, null);

win.open();